_XPG=1
export _XPG
+ # We need the _right_ tr, so must do that first; but if a shell which
+ # we're more confident is sane is available, let's try that. Mostly,
+ # the problem is that "local" is not actually in "the" standard, it's
+ # just in every not-insane shell. Though arguably, there are no shells
+ # with POSIX-ish syntax which qualify as "not insane".
+ for b in /bin/dash /bin/bash /usr/local/bin/bash
+ do
+ if [ -x "$b" ]
+ then
+ SHELL="$b"
+ break
+ fi
+ done
+ # if we get a report of a system with zsh but not bash, we can add that
+ # to the list, but be sure to enable sh_word_split in that case.
+
exec "$SHELL" "$0" "$@"
fi
input=lookups/Makefile.predynamic
-target=lookups/Makefile
-defs_source=Makefile
+target=lookups/Makefile.postdynamic
+defs_source=Makefile-t
tag_marker='MAGIC-TAG-MODS-OBJ-RULES-GO-HERE'
tab=' '
LC_ALL=C
export LC_ALL
+if [ -f "$defs_source" ]
+then
+ :
+ # we are happy
+else
+ echo >&2 "$0: ERROR: MISSING FILE '${defs_source}'"
+ echo >&2 "$0: SHOULD HAVE BEEN CALLED FROM scripts/Configure-Makefile"
+ exit 1
+fi
+
# nb: do not permit leading whitespace for this, as CFLAGS_DYNAMIC is exported
# to the lookups subdir via a line with leading whitespace which otherwise
# matches
-if grep -q "^CFLAGS_DYNAMIC[ $tab]*=" "$defs_source"
+if grep -q "^CFLAGS_DYNAMIC[ $tab?:]*=" "$defs_source"
then
# we have a definition, we're good to go
+ echo >&2 ">>> Creating lookups/Makefile for building dynamic modules"
enable_dynamic=yes
else
- echo >&2 "Missing CFLAGS_DYNAMIC inhibits building dynamic module lookup"
+ echo >&2 ">>> Creating lookups/Makefile without dynamic module support"
enable_dynamic=''
# We always do something now, since there should always be a lookup,
# and now we need to run in order to put the OBJ=$(OBJ)+ rules in. So we
# continue on.
fi
-tmp="$target.t"
-
# For the want_ checks, we need to let the user override values from the make
# command-line, not just check the Makefile.
grep -q "^[ $tab]*$re" "$defs_source"
}
+# Adapted want_at_all above to work for EXPERIMENTAL features
+want_experimental() {
+ local want_name="$1"
+ local re="EXPERIMENTAL_${want_name}[ $tab]*=[ $tab]*."
+ env | grep -q "^$re"
+ if [ $? -eq 0 ]; then return 0; fi
+ grep -q "^[ $tab]*$re" "$defs_source"
+}
+
# The values of these variables will be emitted into the Makefile.
MODS=""
emit_module_rule() {
local lookup_name="$1"
- local mod_name
+ local mod_name pkgconf
if [ "${lookup_name%:*}" = "$lookup_name" ]
then
- mod_name=$(echo $lookup_name | tr A-Z a-z)
+ # Square brackets are redundant but benign for POSIX compliant tr,
+ # however Solaris /usr/bin/tr requires them. Sometimes Solaris
+ # gets installed without a complete set of xpg4 tools, sigh.
+ mod_name=$(echo $lookup_name | tr [A-Z] [a-z])
else
mod_name="${lookup_name#*:}"
lookup_name="${lookup_name%:*}"
if want_dynamic "$lookup_name"
then
if [ -z "$enable_dynamic" ]; then
- echo >&2 "Inhibited dynamic modules prevents building dynamic $lookup_name"
+ echo >&2 "Missing CFLAGS_DYNAMIC prevents building dynamic $lookup_name"
exit 1
fi
MODS="${MODS} ${mod_name}.so"
- grep "^LOOKUP_${lookup_name}_" "$defs_source"
- echo "LOOKUP_${mod_name}_INCLUDE = \$(LOOKUP_${lookup_name}_INCLUDE)"
- echo "LOOKUP_${mod_name}_LIBS = \$(LOOKUP_${lookup_name}_LIBS)"
+ pkgconf=$(grep "^LOOKUP_${lookup_name}_PC" "$defs_source")
+ if [ $? -eq 0 ]; then
+ pkgconf=$(echo $pkgconf | sed 's/^.*= *//')
+ echo "LOOKUP_${mod_name}_INCLUDE = $(pkg-config --cflags $pkgconf)"
+ echo "LOOKUP_${mod_name}_LIBS = $(pkg-config --libs $pkgconf)"
+ else
+ grep "^LOOKUP_${lookup_name}_" "$defs_source"
+ echo "LOOKUP_${mod_name}_INCLUDE = \$(LOOKUP_${lookup_name}_INCLUDE)"
+ echo "LOOKUP_${mod_name}_LIBS = \$(LOOKUP_${lookup_name}_LIBS)"
+ fi
elif want_at_all "$lookup_name"
then
OBJ="${OBJ} ${mod_name}.o"
fi
}
+rm -f "$target"
exec 5>&1
-exec > "$tmp"
+exec > "$target"
sed -n "1,/$tag_marker/p" < "$input"
for name_mod in \
- CDB DBM:dbmdb DNSDB DSEARCH IBASE LSEARCH MYSQL NIS NISPLUS ORACLE \
- PASSWD PGSQL SQLITE TESTDB WHOSON
+ CDB DBM:dbmdb DNSDB DSEARCH IBASE JSON LSEARCH MYSQL NIS NISPLUS ORACLE \
+ PASSWD PGSQL REDIS SQLITE TESTDB WHOSON
do
emit_module_rule $name_mod
done
OBJ="${OBJ} spf.o"
+if want_experimental LMDB
+then
+ OBJ="${OBJ} lmdb.o"
+fi
+
+# readsock is always wanted as it implements the ${readsock } expansion
+OBJ="${OBJ} readsock.o"
+
echo "MODS = $MODS"
echo "OBJ = $OBJ"
sed -n "/$tag_marker/,\$p" < "$input"
exec >&5
-mv "$tmp" "$target"
+# Configure-Makefile will move $target into place
# vim: set ft=sh sw=2 :